unit hiHashTableStringEx;

interface

uses Gvsriable,Windows,Kol,Share,Debug;

type
  ThiHashTableStringEx = class(TDebug)
   private
    FList:PStrList;
    Arr:PArray; 

    procedure _Add(var Val:TData);
    procedure CreateHash;
   private
    FIndex:integer;
    FString:String;
   
   public
    _prop_Char:PChar;
    _prop_FileName:string;
    _prop_AddType:byte;
    _data_FileName:THI_Event;
    _data_str:THI_Event;
    _event_onChange:THI_Event;
    _event_onString:THI_Event;
    _event_onFalse:THI_Event;
    _data_Keystr:THI_Event;
    _data_Keystrb:THI_Event;
    
     constructor Create;
    destructor Destroy; override;
    procedure _work_doKey(var _Data:TData; Index:word);
    procedure _work_doAdd0(var _Data:TData; Index:word);
    procedure _work_doAdd1(var _Data:TData; Index:word);    
    procedure _work_doDelete(var _Data:TData; Index:word);
    procedure _work_doReplace(var _Data:TData; Index:word);
    procedure _work_doLoad(var _Data:TData; Index:word);
    procedure _work_doSave(var _Data:TData; Index:word);
    procedure _var_Text(var _Data:TData; Index:word);
    procedure _var_String(var _Data:TData; Index:word);
    end;

implementation
  var
//MIaKey,PK,l2,PosChSt,aTableSize,aKeylen3:integer;  
MIaKey,PK,l2,PosChSt,aTableSize:integer;  
//aKey,aKey2,aKey3:ShortString;
aKey,aKey2:ShortString;
 aCh: PChar;
HashTable : array of array of integer;
DIMSTAR : array[1..20] of integer;

{   .   5    Pos(), ..
       }
function PosCh(  S: ShortString; StartPos: integer = 1): integer;
var
  i: integer;
  c :PChar ;
begin 
  Result := 0;
  IFS3:= 1;
  for i := StartPos to Length(S) do
  begin 
 
    if (S[i] = Char('=')) then begin
 //   if (S[i] = aCh) then begin
      Result := i;
      exit;             
    end;
     if ( S[i]in[' ',',','.']) then  IFS3 := IFS3 + 1   // in[' ',',','.', #13]
     end;
end;
{   LeftString=RightString}
function RuleLeft(const Rule: string): string;
begin
PosChSt:= PosCh(Rule) ;
  Result := Copy(Rule,1,PosChSt-1);
end;

{   LeftString=RightString}
function RuleRight(const Rule: string): string;
begin
  Result := Copy(Rule,PosChSt+1,Length(Rule));
end;


// HashTableCount:integer;
 {  ,    m}
function FirstSimpleAfter(m: integer): integer;
var
  n, k: integer;
  simple: boolean;
begin
  n := m;
  if n mod 2 = 0 then Inc(n);
  while True do begin
    k := 3;
    simple := True;
    while k*k<n do begin
      if (n mod k = 0) then simple := False;
      Inc(k);
    end;
    if not simple then Inc(n,2)
                  else begin
                    Result := n;
                    exit;
                  end;
  end;
end;

function MatchStrings(cStr:string;cMask:string):boolean;
Var 
 strlen, wclen,lenstr:Integer;

Function MatchPattern(const cStr:string; strlen:Integer; const cMask:string; wclen:Integer): Integer; pascal;
asm     MOV     EAX , 0
        MOV     DWORD [l2],EAX
        MOV     EAX , [EBP + 20]
        SUB     EAX ,  1
        MOV     DWORD [PK],EAX
       	MOV     EAX , ESP 
       	SUB     ESP , $F80
       	MOV EBP, DWORD [EAX+4]
        PUSH    EBP
        MOV EBP, DWORD [EAX]  
   		PUSH    EBP 
   		MOV     EBP , EAX 
   		ADD     EBP , $C
   		PUSH    EBX 
   		PUSH    ESI 
   		PUSH    EDI 
   		MOV     EAX , -4[EBP] 
   		CALL    @@WildCMPU 
   		LEA     EBP , -4[EBP] 
   		MOV     $0[EBP] , EAX 
  		POP     EDI 
  		POP     ESI 
   		POP     EBX 
   		MOV     EAX , ESP 
   		MOV     ESP , EBP 
   		MOV     EBP , [EAX] 
   		MOV     EAX , 4[EAX] 
   		XCHG    EAX , [ESP]
		RET  
    @@DRMOVE:
		POP     EDX 
		MOV     ESI , EAX 
@5530EB:	db $FF,$74,$35,$FC 
		SUB     ESI , $4 
		JNE     @5530EB
		ADD     EBP , EAX 
		MOV     EAX , [EBP]
		LEA     EBP , [EBP +4]
		JMP     EDX 
@@RALLOT:
		POP     EDX 
		MOV     ECX , EAX 
		XOR     EAX , EAX 
@553229:		PUSH    EAX  
		DEC     ECX 
		JNE     @553229
		MOV     EAX , [EBP]
		LEA     EBP , [EBP +4]
		JMP     EDX 
@@LocalsExit:
		POP     EBX 
		ADD     ESP , EBX 
		RET
		
@@WildCMPU:
		MOV     [EBP -4], EAX 
		MOV     EAX , $10
		LEA     EBP , [EBP -4]
		CALL    @@DRMOVE
		MOV     [EBP -4], EAX 
		MOV     EAX , $1
		LEA     EBP , [EBP -4]
		CALL    @@RALLOT
		PUSH     $14
		PUSH    OFFSET [@@LocalsExit]

@574E04:    
		db $81,$7C,$24,$0C,$01,$00,$00,$00 
		JGE     @574E3F
		MOV     ECX , [ESP +20]
		OR      ECX , ECX 
		JNE     @574E1F
		MOV     [EBP -4], EAX 
		XOR     EAX , EAX 
		LEA     EBP , [EBP -4]
		RET
@574E1F:		MOV     [EBP -4], EAX  
		MOV     EAX , [ESP +24]
		MOVZX   EAX , BYTE PTR [EAX ]
		MOV     ECX , EAX 
		AND     ECX , $40	
		LEA     EBP , [EBP -4]
		JNE     @574E39
		XOR     EAX , EAX 
		RET
@574E39:		MOV     EAX , $FFFFFFFF 
		RET
@574E3F:		MOV     ECX , [ESP +20] 
		OR      ECX , ECX 
		JNE     @574E6F
		MOV     [EBP -4], EAX 
		MOV     EAX , [ESP +16]
		MOVZX   EAX , BYTE PTR [EAX ]
		CMP     EAX , $2A
		MOV     EAX , [EBP -4]
		JNE     @574E63
		db $FF,$44,$24,$10
		db $FF,$4C,$24,$0C
@574E63:		MOV     [EBP -4], EAX  
		MOV     EAX , $FFFFFFFF
		LEA     EBP , [EBP -4]
		RET
@574E6F:		MOV     [EBP -4], EAX  
		MOV     EAX , [ESP +16]
		MOVZX   EAX , BYTE PTR [EAX ]
		db $FF,$44,$24,$10
		db $FF,$4C,$24,$0C
		CMP     EAX , $2A
		LEA     EBP , [EBP -4]
		JNE     @574F34
		MOV     EAX , [ESP +24]
		MOV     [ESP +8], EAX 
		MOV     EAX , [ESP +12]
		OR      EAX , EAX 
		MOV     EAX , [EBP ]
		LEA     EBP , [EBP +4]
		JNE     @574EC3
		MOV     [EBP -4], EAX 
		MOV     EAX , [ESP +24]
        SUB     EAX ,  [PK]
        MOV		EBX ,  DWORD [l2]
		MOV     DWORD [DIMSTAR+EBX], EAX  //
		ADD     EBX, 4
		MOV     EAX , [ESP +20]
		MOV     DWORD [DIMSTAR+EBX], EAX  //
		ADD     EBX, 4
		MOV		DWORD [l2],EBX   
		XOR     EAX , EAX 
		LEA     EBP , [EBP -4]  
		RET
@574EC3:		XCHG     EAX, EAX  
@574EC4:		MOV     [EBP -4], EAX  
		MOV     EAX , [ESP +24]
		MOV     [EBP -8], EAX 
		MOV     EAX , [ESP +20]
		MOV     [EBP -12], EAX 
		MOV     EAX , [ESP +16]
		MOV     [EBP -16], EAX    
		MOV     EAX , [ESP +12]
		LEA     EBP , [EBP -16]  
		CALL    @@WildCMPU
		OR      EAX , EAX 
		MOV     EAX , [EBP ]
		LEA     EBP , [EBP +4]
		JNE     @574F14
		MOV     [EBP -4], EAX 
		MOV     EAX , [ESP +8] 
        SUB     EAX ,  [PK]
		MOV		EBX ,  DWORD [l2]
		MOV    DWORD  [DIMSTAR+EBX], EAX  //
		ADD     EBX, 4 
		MOV     EAX , [ESP +24]
		SUB     EAX , [ESP +8]
		MOV    DWORD  [DIMSTAR+EBX], EAX  //
		ADD     EBX, 4
        MOV		DWORD [l2],EBX
		XOR     EAX , EAX 
		LEA     EBP , [EBP -4]  
		RET
@574F14:		MOV     ECX , [ESP +20] 
		OR      ECX , ECX 
		JNE     @574F28
		MOV     [EBP -4], EAX 
		MOV     EAX , $FFFFFFFF
		LEA     EBP , [EBP -4]
		RET
@574F28:		db $FF,$44,$24,$18 
		db $FF,$4C,$24,$14
		JMP     @574EC4
	//	JMP     @574F74
@574F34:		MOV     [EBP -4], EAX  
		MOV     EAX , [ESP +24]
		MOVZX   EAX , BYTE PTR [EAX ]
		CMP     EAX , [EBP -4]
		LEA     EBP , [EBP -4]
		JE      @574F66
		LEA     EAX , [EAX +32]
		XOR     EAX , [EBP ]
		MOV     EAX , [EBP +4]
		LEA     EBP , [EBP +8]
		JE      @574F64
		MOV     [EBP -4], EAX 
		MOV     EAX , $1
		LEA     EBP , [EBP -4]
		RET
@574F64:		JMP     @574F6C 
@574F66:		MOV     EAX , [EBP +4] 
		LEA     EBP , [EBP +8]
@574F6C:		db $FF,$44,$24,$18 
		db $FF,$4C,$24,$14                  
@574F74:		JMP     @574E04 
		RET

end;

 
      
  Begin
//  Result := False;
  strlen:=lenGth(cStr); wclen:=lenGth(cMask); 
   IF  wclen >0 then
  IF MatchPattern(cStr, strlen,cMask,wclen)=0 then  Result:=True else Result:= False
  else  Result:= False
End;
 
 
function PJWHash(const aKey: string; aTableSize: integer): integer;
var
  G: longint;
i: integer;
  Hash: longint;
begin
  Hash := 0;
  for i := 1 to Length(akey) do begin
    Hash := (Hash shl 4)+ord(aKey[i]);
    G := Hash and longint($F0000000);
    if (G <> 0) then
      Hash := (Hash xor (G shr 24)) xor G;
  end;
  Result := Hash mod aTableSize;
end;

constructor ThiHashTableStringEx.Create;
begin
   inherited Create;
   FList := NewStrList;
   FIndex := -1;
end;

destructor ThiHashTableStringEx.Destroy;
begin
   FList.Free;
   if Arr <> nil then dispose(Arr);
   inherited Destroy;
end;


 procedure ThiHashTableStringEx.CreateHash;
var
C: PAnsiChar;
//FString1:String;   
ListLength,i,IaKey,IFS,dubleHash: integer;  
begin
   if (_prop_Char = '') then exit;
   aCh:=_prop_Char;
//   aCh:='='; 
   ListLength:=FList.Count-1;   
   aTableSize:= FirstSimpleAfter(FList.Count);   
   SetLength(HashTable,2);
   SetLength(HashTable[0],aTableSize * 2);
   SetLength(HashTable[1],aTableSize * 2);
   dubleHash:=aTableSize;
      for i := 0 to (aTableSize * 2)-1 do
          begin HashTable[0,i]:=-1; HashTable[1,i]:=-1; end;
   for i := 0 to ListLength do
        begin
       FString := FList.Items[i];
       //      
 //     if char('*') = FString[1] then Delete(FString,1,1);
    //   aKey := Parse(FString,aCh); 
       IaKey:=1; IFS:=1;
 C :=CharLower(@FString[IFS]);
 if  Char( '*' )=C^  then begin Inc(IFS);C :=CharLower(@FString[IFS]) end;
 Repeat
  aKey[IaKey] := C^;  
 Inc(IFS);Inc(IaKey);C :=CharLower(@FString[IFS]); 
 Until C^ in ['=', '*' ];
       SetLength(aKey, IaKey-1);        
       FIndex:=PJWHash(aKey,aTableSize);
      if  HashTable[0,FIndex]=-1 then HashTable[0,FIndex]:= i 
             else 
         begin         
          While  HashTable[1,FIndex] > -1 do
           begin
           FIndex:=HashTable[1,FIndex];                      
            end;
          HashTable[1,FIndex]:=dubleHash;
                HashTable[0,dubleHash]:=i;
          inc(dubleHash); 
        end 
      end;        
      MIaKey := 0;
    //  ListLength:=FList.Count-1;
     for i := 0 to ListLength do
      begin
      FString := FList.Items[i];
      IFS:=1; IaKey:=0;
     Repeat 
      C :=@FString[IFS];
     if C^ = ' ' then inc(IaKey);
     inc(IFS);
     Until C^ = '=';
      MIaKey :=  Max (IaKey, MIaKey);
      end;
end;


procedure ThiHashTableStringEx._work_doKey;
var 
C: PChar;
  Key:ShortString; 
 Lenplus,l22,IK,ILen,ILen2,ILen3,Len,ind, KIndex,aKeylen:integer;
begin //1
  aKey2 := ReadString(_Data,_data_Keystrb);
  aKey := ReadString(_Data,_data_Keystr);
  aKeylen :=  lenGth(aKey);
 while aKeylen > 1 do
  begin //2   
  KIndex:=PJWHash(aKey,aTableSize); 
  ind:= HashTable[0,KIndex]; 
  Key:=RuleLeft(FList.Items[ind]);
  SetLength(aKey2,DIMBL[IFS3] );
  //     
   
 if MatchStrings(aKey2,Key) then   
  begin //3 
//   SetLength(aKey2,DIMBL[IFS3] );
 //  _hi_OnEvent(_event_onFalse,IFS2);
  l22:= l2 div 4;  FString:= RuleRight(FList.Items[ind]); 
 
   
   if l22 = 0 then
    begin
    Lenplus:= lenGth(aKey2) - lenGth(Key); 
    
    If Lenplus=0 then
     _hi_CreateEvent(_Data, @_event_onString,FString)
      else begin FString:=FString + CopyTail(aKey2,Lenplus);
      _hi_CreateEvent(_Data, @_event_onString,FString)  end;
   end  
     else
     begin  //5               
      ILen2:=1;  ILen3 :=0; Len:=lenGth(FString);
       for ILen := 1 to Len do
          begin //6
  
         C:= @FString[ILen];
                       if Char( '*' )=C^ then
                              begin //8
                                 IK :=DIMSTAR[l22]; dec(l22); PK:=DIMSTAR[l22]; dec(l22); 
                                while IK > 0  do     ///////    IFS2
                                 begin
                                C:=@aKey2[PK];
                                if  Char( ' ' )=C^  then  IK := 0 else  begin
                                Key[ILen2]:= C^;                             
                                  inc(ILen2);inc(ILen3); inc(PK); dec(IK);  end;                               
                                 end;
                            end //8    
                       else          
                          begin    Key[ILen2]:=C^; inc(ILen3);inc(ILen2) end;  
         end; //6 
                 SetLength(Key,ILen3 ); _hi_CreateEvent(_Data, @_event_onString,Key); 
                    
     end;  //5 
     exit;                 
  end  //3  
 else 
 
   While  HashTable[1,KIndex] > -1 do
           begin //4
           KIndex:=HashTable[1,KIndex];
           ind:=HashTable[0,KIndex];
           Key:=RuleLeft(FList.Items[ind]);
           //          
        SetLength(aKey2,DIMBL[IFS3] );
       if MatchStrings(aKey2,Key) then  
      begin //7 
    //   SetLength(aKey2,DIMBL[IFS3] );       
  l22:= l2 div 4;  FString:= RuleRight(FList.Items[ind]) ; 
   if l22 = 0 then
    begin
    Lenplus:= lenGth(aKey2) - lenGth(Key);
    If Lenplus=0 then
     _hi_CreateEvent(_Data, @_event_onString,FString)
      else  begin FString:=FString + CopyTail(aKey2,Lenplus);
      _hi_CreateEvent(_Data, @_event_onString,FString) end;
   end  
     else
     begin  //5               
      ILen2:=1;  ILen3 :=0; Len:=lenGth(FString);
       for ILen := 1 to Len do
          begin //6   
         C:= @FString[ILen];
                       if Char( '*' )=C^ then
                              begin //8
                                 IK :=DIMSTAR[l22]; dec(l22); PK:=DIMSTAR[l22]; dec(l22); 
                                while IK > 0 do     ///////
                                 begin
                                C:=@aKey2[PK];
                                      if  Char( ' ' )=C^  then  IK := 0 else begin
                                Key[ILen2]:= C^; 
                                  inc(ILen2);inc(ILen3); inc(PK); dec(IK); end;
                                                                   
                                 end;
                            end //8    
                       else          
                          begin    Key[ILen2]:=C^; inc(ILen3);inc(ILen2) end;     
                                 
                          
   
         end; //6 
                 SetLength(Key,ILen3); _hi_CreateEvent(_Data, @_event_onString,Key);
                        
     end;  //5 
      exit;                
       end; //7        
 end; //4
       dec(aKeylen); SetLength(aKey,aKeylen); 
   end; //2   
end;//1

procedure ThiHashTableStringEx._work_doAdd0;
begin
   FList.Add(ReadString(_Data,_data_str,''));
   CreateHash;
   _hi_CreateEvent(_Data, @_event_onChange);
end;

procedure ThiHashTableStringEx._work_doAdd1;
begin
   FList.Insert(0,ReadString(_Data,_data_str,''));
   CreateHash;
   _hi_CreateEvent(_Data, @_event_onChange);
end; 

procedure ThiHashTableStringEx._work_doDelete;
var   ind:integer;
begin
     if (FIndex < 0) or (FIndex > FList.Count - 1) then exit;
   FList.Delete(FIndex);
   CreateHash;
   _hi_CreateEvent(_Data, @_event_onChange);
end;

procedure ThiHashTableStringEx._work_doReplace;
var   ind:integer;
begin
   ind := ToIntIndex(_Data);
   if (FIndex < 0) or (FIndex > FList.Count - 1) then exit;
   FList.Delete(FIndex);
   FList.Insert(FIndex, ReadString(_Data, _data_str, ''));
    CreateHash;   
   _hi_CreateEvent(_Data, @_event_onChange);
end;

procedure ThiHashTableStringEx._work_doLoad;
var   fn:string;
begin
   fn := ReadString(_Data,_data_FileName,_prop_FileName);
   if FileExists(fn) then begin
      FList.LoadFromFile(fn);
 CreateHash;
 _hi_CreateEvent(_Data, @_event_onChange);     
   end;
end;

procedure ThiHashTableStringEx._work_doSave;
var   fn:string;
begin
   fn := ReadString(_Data,_data_FileName,_prop_FileName);
   FList.SaveToFile(fn);
end;


procedure ThiHashTableStringEx._var_Text;
begin
//   dtString(_Data,FList.Text);
     dtinteger(_Data,MIaKey );
end;

procedure ThiHashTableStringEx._var_String;
begin
  dtString(_Data,FString);
end;

procedure ThiHashTableStringEx._Add;
begin
   FList.Add(ToString(val));
  end;
end.